//
//		File: kiol1037.js
//		By: Mark Anderson, 2006-01-15
//		
//		This file is a part of the KIOL_103.7_FM widget. 

var stationNowPlayingLink;
var stationNowPlayingLinkHistory;
var historyPathFile;
var stationLink;
var wmpIsMuted = false;
var songTitle;
var artistName;
var mydate;
var isNow;
var echoCommand;
var playStatus = "play";
var oldNowPlaying;
var myurl;
var urlStreamData;
var nowPlaying;
var trayPosition = "down";

//		Load Widget preferences 
function loadStationChoice() 
	{	
	stationLink = preferences.radiostationLinkPref.value;
	stationNowPlayingLink = preferences.dmarcNowPlayingLinkPref.value;
	stationNowPlayingLinkHistory = preferences.nowPlayingLinkHistoryPref.value;
	historyPathFile = preferences.historyPathFilePref.value;
	bgimage1.opacity = preferences.backgroundOpacityPref.value;
	if (bgimage1.opacity == "0")
		{
			preferences.backgroundOpacityPref.value = "1";
			bgimage1.opacity = preferences.backgroundOpacityPref.value;
		}
	nowPlayingTxt.color = preferences.nowPlayingColorPref.value;
	stationCallSignMute.data = preferences.radiostationTitlePref.value;
	nowPlayingTxt.data = "Loading Now Playing Information . . . . . .";
//		Change to http://stations.dmarc.net/dmarcreports/services.asmx/getEmulatorData?call_sign=KIOL for KIOL settings
	if (stationNowPlayingLink == "http://stations.dmarc.net/dmarcreports/services.asmx/getEmulatorData?call_sign=KIOL")
		{
		preferences.dmarcNowPlayingLinkPref.value = "http://services.dmarc.net/rdsmgr/getEmulatorData?call=KIOL-FM";
		stationNowPlayingLink = preferences.dmarcNowPlayingLinkPref.value;
		}
	if (stationNowPlayingLinkHistory == "http://stations.dmarc.net/Console/NextPlays.aspx?c=KIOL-FM&tz=CST")
		{
		preferences.nowPlayingLinkHistoryPref.value = "http://stations.dmarc.net/Console/NextPlays.aspx?c=KIOL-FM&tz=CST";
		stationNowPlayingLinkHistory = preferences.nowPlayingLinkHistoryPref.value;
		}
	}

// Set back to defaults for KIOL
function setDefaults()
	{
	if (preferences.reset2Default.value == 1)
		{
		preferences.radiostationLinkPref.value = "http://www.streamaudio.com/stations/asx/KIOL_FM.asx";
		preferences.dmarcNowPlayingLinkPref.value = "http://services.dmarc.net/rdsmgr/getEmulatorData?call=KIOL-FM";
		preferences.nowPlayingLinkHistoryPref.value = "http://stations.dmarc.net/Console/NextPlays.aspx?c=KIOL-FM&tz=CST";
		preferences.historyPathFilePref.value = "C:\\KIOL_PlayList.txt";
		preferences.backgroundOpacityPref.value = "255";
		preferences.nowPlayingColorPref.value = "#C0FFFF";
		preferences.radiostationTitlePref.value = "KIOL 103.7";
		preferences.reset2Default.value = 0;
		loadStationChoice();
		}
	}

//		Fetch Now Playing data and parse it out
function handleTimer()
	{
	oldNowPlaying = nowPlayingTxt.data;
	myurl = new URL();
	myurl.location = stationNowPlayingLink;
	urlStreamData = myurl.fetch();
// print("urlStreamData = " + urlStreamData);
	myurl.location = "";
//		Skip if no Artist data & it is really song info & not commercial
	if (urlStreamData.search(/<Artist>/) != -1 && urlStreamData.search("998") != -1)
		{
		artistName = urlStreamData.slice((urlStreamData.search(/<Artist>/) + 8),(urlStreamData.search("</Artist>")));
//		songTitle = urlStreamData.slice((urlStreamData.search(/<Song>/) + 6),(urlStreamData.search("</Song>")));
		songTitle = urlStreamData.slice((urlStreamData.search(/<Title>/) + 7),(urlStreamData.search("</Title>")));
		urlStreamData = "";
		nowPlaying = capitalise(artistName + " - " + songTitle);
		nowPlaying = nowPlaying.replace(/[\n\r\v\f\t]/g, "");
//		Only update when it changes
		if (nowPlaying != oldNowPlaying)
			{
			nowPlayingTxt.data = nowPlaying;
			mydate = new Date()
			isNow = mydate.toLocaleString();
//		Build a DOS Echo command, put a CR at the end of the nowPlaying line and append it to the file
			echoCommand = 'echo "' + isNow + " : " + nowPlaying + '\r" >> "' + historyPathFile + '"';
			str = runCommand(echoCommand);
			mydate = "";
			echoCommand = "";
			nowPlaying = "";
			}
		}
	}

//		Windows Media Player - Toggle streaming
function playRadioWM()
	{
		if(playStatus == "play")
		{
			PlayerWM.controls.stop();
			Start.src = "Resources/StreamOff.gif";
			playStatus = "stop";
		}	else {
			PlayerWM.URL = radioStation;
			PlayerWM.controls.play();
			Start.src = "Resources/StreamOn.gif";
			playStatus = "play";
		}
//		print(playStatus);
	}

//		Windows Media Player - Start streaming first time
function startPlayRadioWM()
	{
			PlayerWM.URL = radioStation;
			PlayerWM.controls.play();
			Start.src = "Resources/StreamOn.gif";
			playStatus = "play";
//		print(playStatus);
	}

//		Windows Media Player - Mute
function muteRadioWM()
	{
		if (wmpIsMuted)
		{
			PlayerWM.settings.mute = false;
			stationCallSignMute.color = "#FF0000";
			wmpIsMuted = false;
		} else {
			PlayerWM.settings.mute = true;
			stationCallSignMute.color = "#FFFF00";
			wmpIsMuted = true;
		}
	}

function slideLast20()
	{
	if(trayPosition == "up") {
		getAndParseHistory();
		var a = new FadeAnimation(textFrame, 255, 500, animator.kEaseOut);
		var b = new FadeAnimation(bgimage1, 255, 500, animator.kEaseOut);
		bgimage1.slide("down", 94, 10);
		trayPosition = "down";
		animator.runUntilDone(new Array(a,b));
		} 
	else {
		var a = new FadeAnimation(textFrame, 0, 500, animator.kEaseOut);
		var b = new FadeAnimation(bgimage1, preferences.backgroundOpacityPref.value, 500, animator.kEaseOut);
		animator.runUntilDone(new Array(a,b));
		bgimage1.slide("up", 94, 10);
		trayPosition = "up";
		}
	}

function getAndParseHistory()
	{
		try{
			var fetchurl = new URL();
			fetchurl.location = stationNowPlayingLinkHistory + "&n=20";
			var urlstreamData = fetchurl.fetch();
			if(fetchurl.response == 200 && urlstreamData !=null) {
//				print("");
//				print("urlstreamData = " + urlstreamData);
				// This strips out all the html tags in the nowPlaying data stream
				var nowPlaying = urlstreamData.replace(/(<([^>]+)>)/ig,"");
//				print("NP1 = " + nowPlaying);
				// This strips out other tags and creates XML version
				// Strip off " first so nothing gets screwed up
				nowPlaying = nowPlaying.replace(/\"/ig,"");
				// Replace ‡ with ~ just in case it is in data so we can use it later
				nowPlaying = nowPlaying.replace(/(‡)+/ig,"~");
				// Add a ~ for those entries that have no artist or song data
				nowPlaying = nowPlaying.replace(/(&nbsp;&nbsp;&nbsp;&nbsp;)+/ig,"&nbsp;&nbsp;~&nbsp;&nbsp;");
				// Put in our delimiter ‡
				nowPlaying = nowPlaying.replace(/(&nbsp;)+/ig,"‡");
				// Strip off ()
				nowPlaying = nowPlaying.replace(/\(\)/ig,"");
				// Replace ‡‡ with ‡
				nowPlaying = nowPlaying.replace(/(‡‡)+/ig,"‡");
				// Replace space‡ with ‡
				nowPlaying = nowPlaying.replace(/( ‡)/ig,"‡");
//				print("NP2 = " + nowPlaying);
				// Put the header on
				nowPlaying = '<?xml version="1.0" standalone="yes" ?><Playing>' + nowPlaying;
				// Loop through all 20 songs and put in XML tags
				for(var i = 0; i <= 19; i++){
					// Replace first ‡ with <Song><date>
					nowPlaying = nowPlaying.replace("‡","<Song><date>");
					// Replace second ‡ with </date><time>
					nowPlaying = nowPlaying.replace("‡","</date><time>");
					// Replace third ‡ with </time><artist>
					nowPlaying = nowPlaying.replace("‡","</time><artist>");
					// Replace fourth ‡ with </artist><title>
					nowPlaying = nowPlaying.replace("‡","</artist><title>");
					// Replace fifth ‡ with </title></Song>‡
					nowPlaying = nowPlaying.replace("‡","</title></Song>‡");
					var itemNum = i + 1;
				}
				// Replace ending ‡ with </Playing> to close out XML creation
				nowPlaying = nowPlaying.replace("‡","</Playing>");
//				print("NP - XML = " + nowPlaying);
				data = XMLDOM.parse(nowPlaying);
				var dates = data.evaluate("Playing/Song/date");
				var times = data.evaluate("Playing/Song/time");
				var artists = data.evaluate("Playing/Song/artist");
				var titles = data.evaluate("Playing/Song/title");
				for(var i = 0; i <= 19; i++) {
					var itemNum = i + 1;
					try {
						date = dates.item(i).firstChild.data + "   ";
					} catch(err) {
							date = "";
						}
					try {
						time = times.item(i).firstChild.data + "                ";
					} catch(err) {
							time = "";
						}
					try {
						artist = capitalise(artists.item(i).firstChild.data + " - ");
					} catch(err) {
							artist = "";
						}
					try {
						title = capitalise(titles.item(i).firstChild.data);
					} catch(err) {
							title = "";
						}
					var setWhen = "when" + itemNum + ".data=\"" + date + time + "\"";
					var setArtist = "artist" + itemNum + ".data=\"" + artist + title + "\"";
					eval(setWhen);
					eval(setArtist);
				}
			}
		} catch(err) {
				print(err.message);
			}
	}

// Lower case everything and then upper case the first letter of each word. Ac/Dc & Zz Top come out wrong but .... 
function mapMatches(r,f,x) {
	while (r.test(x)) {
		x = RegExp.leftContext + f(RegExp.lastMatch) + RegExp.rightContext;
	}
	return x;
}

function toUpper(x) {
	return x.toUpperCase();
}

function capitalise(x) {
	x = x.toLowerCase();
	x = mapMatches(/\b[a-z]/,toUpper,x);
	return x;
}

savePreferences();